'\"<-xtx-*>eqn -Tpsc $CADIZ/mip/pub/zchars $XTX >function_toolkit.z ; cadiz -l function_toolkit
.EQ
delim $$
gfont HR
.EN
.TL
Mathematical toolkit
.AU
This is public domain material,
.br
as presented in the Z Standard (ISO/IEC 13568:2002).
'\"-------------------------
.NH 1
Functions
.LP
.ZH
section function_toolkit parents relation_toolkit
.ZE
'\"-------------------
.NH 2
Partial functions
.LP
.Zo pfx U+21F8
.ZH
generic 5 rightassoc ( _ pfx _ )
.ZE
.ZH
X pfx Y == { f : X rel Y | forall p , q : f | p.1 = q.1 dot p.2 = q.2 }
.ZE
$X~pfx~Y$ is the set of all partial functions from $X$ to $Y$,
that is, the set of all relations between $X$ and $Y$ such that
each $x$ in $X$ is related to at most one $y$ in $Y$.
The terms ``function'' and ``partial function'' are synonymous.
'\"-------------------
.NH 2
Partial injections
.LP
.Zo pinj U+2914
.ZH
generic 5 rightassoc ( _ pinj _ )
.ZE
.ZH
X pinj Y == { f : X rel Y | forall p, q : f dot p.1 = q.1 iff p.2 = q.2 }
.ZE
$X~pinj~Y$ is the set of partial injections from $X$ to $Y$,
that is, the set of all relations between $X$ and $Y$ such that
each $x$ in $X$ is related to no more than one $y$ in $Y$,
and each $y$ in $Y$ is related to no more than one $x$ in $X$.
The terms ``injection'' and ``partial injection'' are synonymous.
'\"-------------------
.NH 2
Total injections
.LP
.Zo inj U+21A3
.ZH
generic 5 rightassoc ( _ inj _ )
.ZE
.ZH
X inj Y == ( X pinj Y ) sand ( X fx Y )
.ZE
$X~inj~Y$ is the set of total injections from $X$ to $Y$,
that is, the set of injections from $X$ to $Y$
that are also total functions from $X$ to $Y$.
'\"-------------------
.NH 2
Partial surjections
.LP
.Zo psurj U+2900
.ZH
generic 5 rightassoc ( _ psurj _ )
.ZE
.ZH
X psurj Y == { f : X pfx Y | ran f = Y }
.ZE
$X~psurj~Y$ is the set of partial surjections from $X$ to $Y$,
that is, the set of functions from $X$ to $Y$
whose range is equal to $Y$.
The terms ``surjection'' and ``partial surjection'' are synonymous.
'\"-------------------
.NH 2
Total surjections
.LP
.Zo surj U+21A0
.ZH
generic 5 rightassoc ( _ surj _ )
.ZE
.ZH
X surj Y == ( X psurj Y) sand ( X fx Y )
.ZE
$X~surj~Y$ is the set of total surjections from $X$ to $Y$,
that is, the set of surjections from $X$ to $Y$
that are also total functions from $X$ to $Y$.
'\"-------------------
.NH 2
Bijections
.LP
.Zo bij U+2916
.ZH
generic 5 rightassoc ( _ bij _ )
.ZE
.ZH
X bij Y == ( X surj Y ) sand ( X inj Y )
.ZE
$X~bij~Y$ is the set of bijections from $X$ to $Y$,
that is, the set of total surjections from $X$ to $Y$
that are also total injections from $X$ to $Y$.
'\"-------------------
.NH 2
Finite functions
.LP
.Zo pffx U+21FB
.ZH
generic 5 rightassoc ( _ pffx _ )
.ZE
.ZH
X pffx Y == (X pfx Y) sand fss (X cp Y)
.ZE
The finite functions from $X$ to $Y$ are the functions from $X$ to $Y$
that are also finite sets.
'\"-------------------
.NH 2
Finite injections
.LP
.Zo finj U+2915
.ZH
generic 5 rightassoc ( _ finj _ )
.ZE
.ZH
X finj Y == ( X pffx Y ) sand ( X pinj Y )
.ZE
The finite injections from $X$ to $Y$ are the injections from $X$ to $Y$
that are also finite functions from $X$ to $Y$.
'\"-------------------
.NH 2
Disjointness
.LP
.ZH
relation ( disjoint _ )
.ZE
.ZS [L,X]
disjoint _ : ps ( L rel ps X )
.ZM
forall f : L rel ps X dot
disjoint f iff ( forall p , q : f | p <> q dot p.2 sand q.2 = empty )
.ZE
A labelled family of sets is disjoint precisely when any
distinct pair yields sets with no members in common.
'\"-------------------
.NH 2
Partitions
.LP
.ZH
relation ( _ partition _ )
.ZE
.ZS [L,X]
_ partition _ : ( L rel ps X ) rel ps X
.ZM
forall f : L rel ps X ; a : ps X dot
f partition a iff disjoint f and dor ( ran f ) = a
.ZE
A labelled family of sets $f$ partitions a set $a$
precisely when $f$ is disjoint and the union of all the sets in $f$
is $a$.
