'\"<-xtx-*>eqn -Tpsc $CADIZ/mip/pub/zchars $XTX >relation_toolkit.z ; cadiz -l relation_toolkit
.EQ
delim $$
gfont HR
.EN
.TL
Mathematical toolkit
.AU
This is public domain material,
.br
as presented in the Z Standard (ISO/IEC 13568:2002).
'\"-------------------------
.NH 1
More notations for relations
.LP
.ZH
section relation_toolkit parents set_toolkit
.ZE
'\"-------------------
.NH 2
First component projection
.LP
.ZS [X,Y]
first : X cp Y fx X
.ZM
forall p : X cp Y dot first p = p . 1
.ZE
For any ordered pair $p$,
$first~p$ is the first component of the pair.
'\"-------------------
.NH 2
Second component projection
.LP
.ZS [X,Y]
second : X cp Y fx Y
.ZM
forall p : X cp Y dot second p = p . 2
.ZE
For any ordered pair $p$,
$second~p$ is the second component of the pair.
'\"-------------------
.NH 2
Maplet
.LP
.Zo mlet U+21A6
.ZH
function 10 leftassoc ( _ mlet _ )
.ZE
.ZS [X,Y]
_ mlet _ : X cp Y fx X cp Y
.ZM
forall x : X ; y : Y dot x mlet y = ( x , y )
.ZE
The maplet forms an ordered pair from two values;
$x~mlet~y$ is just another notation for $(x, y)$.
'\"-------------------
.NH 2
Domain
.LP
.ZS [X,Y]
dom : (X rel Y) fx ps X
.ZM
forall r : X rel Y dot dom r = { p : r dot p.1 }
.ZE
The domain of a relation $r$ is the set of first components of the ordered
pairs in $r$.
'\"-------------------
.NH 2
Range
.LP
.ZS [X,Y]
ran : (X rel Y) fx ps Y
.ZM
forall r : X rel Y dot ran r = { p : r dot p.2 }
.ZE
The range of a relation $r$ is the set of second components of the ordered
pairs in $r$.
'\"-------------------
.NH 2
Identity relation
.LP
.ZH
generic ( id _ )
.ZE
.ZH
id X == { x : X dot x mlet x }
.ZE
The identity relation on a set $X$ is the relation that relates every
member of $X$ to itself.
'\"-------------------
.NH 2
Relational composition
.LP
.Zo frc U+2A3E
.ZH
function 40 leftassoc ( _ frc _ )
.ZE
.ZS [X,Y,Z]
_ frc _ : (X rel Y) cp (Y rel Z) fx (X rel Z)
.ZM
forall r : X rel Y ; s : Y rel Z dot
 r frc s = { p : r ; q : s | p.2 = q.1 dot p.1 mlet q.2 }
.ZE
The relational composition of a relation $r~:~X~rel~Y$ and $s~:~Y~rel~Z$
is a relation of type $X~rel~Z$ formed by taking
all the pairs $p$ of $r$ and $q$ of $s$,
where the second component of $p$ is equal to the first component of $q$,
and relating the first component of $p$ with the second component of $q$.
'\"-------------------
.NH 2
Functional composition
.LP
.Zo rc U+2218
.ZH
function 40 leftassoc ( _ rc _ )
.ZE
.ZS [X,Y,Z]
_ rc _ : (Y rel Z) cp (X rel Y) fx (X rel Z)
.ZM
forall r : X rel Y ; s : Y rel Z dot s rc r = r frc s
.ZE
The functional composition of $s$ and $r$ is the same as
the relational composition of $r$ and $s$.
'\"-------------------
.NH 2
Domain restriction
.LP
.Zo dres U+25C1
.ZH
function 65 rightassoc ( _ dres _ )
.ZE
.ZS [X,Y]
_ dres _ : ps X cp ( X rel Y ) fx ( X rel Y )
.ZM
forall a : ps X ; r : X rel Y dot a dres r = { p : r | p.1 mem a }
.ZE
The domain restriction of a relation $r~:~X~rel~Y$ by a set $a~:~ps~X$ is
the set of pairs in $r$ whose first components are in $a$.
'\"-------------------
.NH 2
Range restriction
.LP
.Zo rres U+25B7
.ZH
function 60 leftassoc ( _ rres _ )
.ZE
.ZS [X,Y]
_ rres _ : ( X rel Y) cp ps Y fx ( X rel Y )
.ZM
forall r : X rel Y ; b : ps Y dot r rres b = { p : r | p.2 mem b }
.ZE
The range restriction of a relation $r~:~X~rel~Y$ by a set $b~:~ps~Y$ is
the set of pairs in $r$ whose second components are in $b$.
'\"-------------------
.NH 2
Domain subtraction
.LP
.Zo dsub U+2A64
.ZH
function 65 rightassoc ( _ dsub _ )
.ZE
.ZS [X,Y]
_ dsub _ : ps X cp ( X rel Y ) fx ( X rel Y )
.ZM
forall a : ps X ; r : X rel Y dot a dsub r = { p : r | p.1 notmem a }
.ZE
The domain subtraction of a relation $r~:~X~rel~Y$ by
a set $a~:~ps~X$
is the set of pairs in $r$ whose first components are not in $a$.
'\"-------------------
.NH 2
Range subtraction
.LP
.Zo rsub U+2A65
.ZH
function 60 leftassoc ( _ rsub _ )
.ZE
.ZS [X,Y]
_ rsub _ : ( X rel Y) cp ps Y fx ( X rel Y )
.ZM
forall r : X rel Y ; b : ps Y dot
r rsub b = { p : r | p.2 notmem b }
.ZE
The range subtraction of a relation $r~:~X~rel~Y$ by a set $b~:~ps~Y$
is the set of pairs in $r$ whose second components are not in $b$.
'\"-------------------
.NH 2
Relational inversion
.LP
.Zo inv U+223C
.ZH
function ( _ inv )
.ZE
.ZS [X,Y]
_ inv : ( X rel Y ) fx ( Y rel X )
.ZM
forall r : X rel Y dot r inv = { p : r dot p.2 mlet p.1 }
.ZE
The inverse of a relation is the relation obtained by reversing every
ordered pair in the relation.
'\"-------------------
.NH 2
Relational image
.LP
.Zo opimg U+2987
.Zo climg U+2988
.ZH
function ( _ opimg _ climg )
.ZE
.ZS [X,Y]
_ opimg _ climg : ( X rel Y ) cp ps X fx ps Y
.ZM
forall r : X rel Y ; a : ps X dot r opimg a climg = { p : r | p.1 mem a dot p.2 }
.ZE
The relational image of a set $a~:~ps~X$ through a relation $r~:~X~rel~Y$
is the set of values of type $Y$ that are related under $r$ to a value in $a$.
'\"-------------------
.NH 2
Overriding
.LP
.Zo fxov U+2295
.ZH
function 50 leftassoc ( _ fxov _ )
.ZE
.ZS [X,Y]
_ fxov _ : ( X rel Y ) cp ( X rel Y ) fx ( X rel Y )
.ZM
forall r , s : X rel Y dot r fxov s = ( ( dom s ) dsub r ) sor s
.ZE
If $r$ and $s$ are both relations between $X$ and $Y$,
the overriding of $r$ by $s$
is the whole of $s$ together with those members of $r$
that have no first components that are in the domain of $s$.
'\"-------------------
.NH 2
Transitive closure
.LP
.Zw nrtc nearrow+swarrow
.ZH
function ( _ nrtc )
.ZE
.ZS [X]
_ nrtc : ( X rel X ) fx (X rel X )
.ZM
forall r : X rel X dot
r nrtc = dand { s : X rel X | r sinc s and r frc s sinc s }
.ZE
The transitive closure of a relation $r~:~X~rel~X$ is
the smallest set that contains $r$ and
is closed under the action of composing $r$ with its members.
'\"-------------------
.NH 2
Reflexive transitive closure
.LP
.Zw rtc nearrow*swarrow
.ZH
function ( _ rtc )
.ZE
.ZS [X]
_ rtc : ( X rel X ) fx (X rel X )
.ZM
forall r : X rel X dot r rtc = r nrtc sor id X
.ZE
The reflexive transitive closure of a relation $r~:~X~rel~X$ is the
relation formed by extending the transitive closure of $r$ by the identity
relation on $X$.
