'\"<-xtx-*>eqn -Tpsc $CADIZ/mip/pub/zchars $XTX >sequence_toolkit.z ; cadiz -l sequence_toolkit
.EQ
delim $$
gfont HR
.EN
.TL
Mathematical toolkit
.AU
This is public domain material,
.br
as presented in the Z Standard (ISO/IEC 13568:2002).
'\"-------------------------
.NH 1
Sequences
.LP
.ZH
section sequence_toolkit parents function_toolkit, number_toolkit
.ZE
'\"-------------------
.NH 2
Number range
.LP
.ZH
function 20 leftassoc ( _ .. _ )
.ZE
.ZS
_ .. _ : arithmos cp arithmos pfx ps arithmos
.ZM
(ints cp ints) dres (_ .. _) mem ints cp ints fx ps ints
forall i , j : ints dot i .. j = { k : ints | i <= k <= j }
.ZE
The number range from $i$ to $j$ is the set of all integers
greater than or equal to $i$,
which are also less than or equal to $j$.
'\"-------------------
.NH 2
Iteration
.LP
.ZS [X]
iter : nn fx (X rel X) fx (X rel X)
.ZM
forall r : X rel X dot iter 0 r = id X
forall r : X rel X; n : nn dot iter(n+1)r = r frc (iter n r)
forall r : X rel X; n : nn dot iter (negate n) r = iter n (r inv)
.ZE
$iter$ is the iteration function for a relation.
The iteration of a relation $r~:~X~rel~X$ for zero times is the
identity relation on $X$.
The iteration of a relation $r~:~X~rel~X$ for $n+1$ times is the 
composition of the relation with its iteration $n$ times.
The iteration of a relation $r~:~X~rel~X$ for $-~n$ times is the
iteration for $n$ times of the inverse of the relation.
.Zw iterup nearrow
.Zw iterdown swarrow
.ZH
function ( _ iterup _ iterdown )
.ZE
.ZS [X]
_ iterup _ iterdown : (X rel X) cp ints fx (X rel X)
.ZM
forall r : X rel X; n : nn dot r iterup n iterdown = iter n r
.ZE
$iter~n~r$ may be written as $r sup n$.
'\"-------------------
.NH 2
Number of members of a set
.LP
.Zo length U+0023
.ZH
function (length _)
.ZE
.ZS [X]
length _ : fss X fx nn
.ZM
forall a : fss X dot length a = (mu n : nn | ( exists f : 1 .. n inj a dot ran f = a ) )
.ZE
The number of members of a finite set is the upper limit of the number
range starting at $1$ that can be put into bijection with the set.
'\"-------------------
.NH 2
Minimum
.LP
.ZH
function (min _)
.ZE
.ZS
min _ : ps arithmos pfx arithmos
.ZM
ps ints dres (min _) = { a : ps ints ; m : ints | m mem a and ( forall n : a dot m <= n ) dot a mlet m }
.ZE
If a set of integers has a member that is less than or equal
to all members of that set,
that member is its minimum.
'\"-------------------
.NH 2
Maximum
.LP
.ZH
function (max _)
.ZE
.ZS
max _ : ps arithmos pfx arithmos
.ZM
ps ints dres (max _) = { a : ps ints ; m : ints | m mem a and ( forall n : a dot n <= m ) dot a mlet m }
.ZE
If a set of integers has a member that is greater than or equal
to all members of that set,
that member is its maximum.
'\"-------------------
.NH 2
Finite sequences
.LP
.ZH
generic ( seq _ )
.ZE
.ZH
seq X == { f : nn pffx X | dom f = 1 .. length f }
.ZE
A finite sequence is a finite indexed set of values of the same type,
whose domain is a contiguous set of positive integers starting at $1$.

$seq~X$ is the set of all finite sequences of values of $X$,
that is, of finite functions from the set $1~..~n$,
for some $n$, to elements of $X$.
'\"-------------------
.NH 2
Non-empty finite sequences
.LP
.ZH
seq^1 X == seq X sdiff { empty }
.ZE
$seq sub 1~X$ is the set of all non-empty finite sequences of values of $X$.
'\"-------------------
.NH 2
Injective sequences
.LP
.ZH
generic ( iseq _ )
.ZE
.ZH
iseq X == seq X sand (nn pinj X)
.ZE
$iseq~X$ is the set of all injective finite sequences of values of $X$,
that is, of finite sequences over $X$ that are also injections.
'\"-------------------
.NH 2
Sequence brackets
.LP
.Zo opseq U+27E8
.Zo clseq U+27E9
.ZH
function ( opseq ,, clseq )
.ZE
.ZH
opseq ,, clseq [ X ] == lambda s : seq X dot s
.ZE
The brackets $opseq$ and $clseq$ can be used for enumerated sequences.
'\"-------------------
.NH 2
Concatenation
.LP
.Zo cat U+2040
.ZH
function 30 leftassoc ( _ cat _ )
.ZE
.ZS [X]
_ cat _ : seq X cp seq X fx seq X
.ZM
forall s , t : seq X dot
s cat t = s sor { n : dom t dot n + length s mlet t n }
.ZE
Concatenation is a function of a pair of finite sequences of
values of the same type whose result is a sequence that
begins with all elements of the first sequence and
continues with all elements of the second sequence.
'\"-------------------
.NH 2
Reverse
.LP
.ZS [X]
rev : seq X fx seq X
.ZM
forall s : seq X dot rev s = ( lambda n : dom s dot s ( length s - n + 1 ) )
.ZE
The reverse of a sequence is the sequence obtained by taking its
elements in the opposite order.
'\"-------------------
.NH 2
Head of a sequence
.LP
.ZS [X]
head : seq^1 X fx X
.ZM
forall s : seq^1 X dot head s = s 1
.ZE
If $s$ is a non-empty sequence of values,
then $head~s$ is the value that is first in the sequence.
'\"-------------------
.NH 2
Last of a sequence
.LP
.ZS [X]
last : seq^1 X fx X
.ZM
forall s : seq^1 X dot last s = s ( length s )
.ZE
If $s$ is a non-empty sequence of values,
then $last~s$ is the value that is last in the sequence.
'\"-------------------
.NH 2
Tail of a sequence
.LP
.ZS [X]
tail : seq^1 X fx seq X
.ZM
forall s : seq^1 X dot tail s = lambda n : 1 .. (length s - 1) dot s ( n + 1 )
.ZE
If $s$ is a non-empty sequence of values,
then $tail~s$ is the sequence of values that is obtained from $s$
by discarding the first element and renumbering the remainder.
'\"-------------------
.NH 2
Front of a sequence
.LP
.ZS [X]
front : seq^1 X fx seq X
.ZM
forall s : seq^1 X dot front s = { length s } dsub s
.ZE
If $s$ is a non-empty sequence of values,
then $front~s$ is the sequence of values that is obtained from $s$
by discarding the last element.
'\"-------------------
.NH 2
Squashing
.LP
.ZS [X]
squash : ( ints pffx X ) fx seq X
.ZM
forall f : ints pffx X dot squash f =
	{ p : f dot length { i : dom f | i <= p.1 } mlet p.2 }
.ZE
$squash$ takes a finite function $f~:~ints~pffx~X$
and renumbers its domain to produce a finite sequence.
'\"-------------------
.NH 2
Extraction
.LP
.Zo extract U+21BF
.ZH
function 45 rightassoc ( _ extract _ )
.ZE
.ZS [X]
_ extract _ : ps ints cp seq X fx seq X
.ZM
forall a : ps ints ; s : seq X dot
	a extract s = squash ( a dres s )
.ZE
The extraction of a set $a$ of indices from a sequence
is the sequence obtained from the original by discarding any indices
that are not in the set $a$,
then renumbering the remainder.
'\"-------------------
.NH 2
Filtering
.LP
.Zo filter U+21BE
.ZH
function 40 leftassoc ( _ filter _ )
.ZE
.ZS [X]
_ filter _ : seq X cp ps X fx seq X
.ZM
forall s : seq X ; a : ps X dot
	s filter a = squash ( s rres a )
.ZE
The filter of a sequence by a set $a$
is the sequence obtained from the original by discarding any members
that are not in the set $a$,
then renumbering the remainder.
'\"-------------------
.NH 2
Prefix relation
.LP
.ZH
relation ( _ prefix _ )
.ZE
.ZS [X]
_ prefix _ : seq X rel seq X
.ZM
forall s,t: seq X dot
s prefix t iff s sinc t
.ZE
A sequence $s$ is a prefix of another sequence $t$
if it forms the front portion of $t$.
'\"-------------------
.NH 2
Suffix relation
.LP
.ZH
relation ( _ suffix _ )
.ZE
.ZS [X]
_ suffix _ : seq X rel seq X
.ZM
forall s,t: seq X dot
s suffix t iff ( exists u: seq X dot u cat s = t)
.ZE
A sequence $s$ is a suffix of another sequence $t$
if it forms the end portion of $t$.
'\"-------------------
.NH 2
Infix relation
.LP
.ZH
relation ( _ infix _ )
.ZE
.ZS [X]
_ infix _ : seq X rel seq X
.ZM
forall s,t: seq X dot
s infix t iff ( exists u,v: seq X dot u cat s cat v = t)
.ZE
A sequence $s$ is an infix of another sequence $t$
if it forms a mid portion of $t$.
'\"-------------------
.NH 2
Distributed concatenation
.LP
.Zw dcat cat/
.ZS [X]
dcat : seq seq X fx seq X
.ZM
dcat opseq clseq = opseq clseq
forall s : seq X dot dcat opseq s clseq = s
forall q , r : seq seq X dot dcat ( q cat r ) = ( dcat q ) cat ( dcat r )
.ZE
The distributed concatenation of a sequence $t$
of sequences of values of type $X$
is the sequence of values of type $X$
that is obtained by concatenating the members of $t$ in order.
