'\"<-xtx-*>eqn -Tpsc $CADIZ/mip/pub/zchars $XTX >set_toolkit.z ; cadiz -l set_toolkit
.EQ
delim $$
gfont HR
.EN
.TL
Mathematical toolkit
.AU
This is public domain material,
.br
as presented in the Z Standard (ISO/IEC 13568:2002).
'\"-------------------------
.NH 1
Preliminary definitions
.LP
.ZH
section set_toolkit
.ZE
'\"-------------------
.NH 2
Relations
.LP
.Zo rel U+2194
.ZH
generic 5 rightassoc ( _ rel _ )
.ZE
.ZH
X rel Y == ps ( X cp Y )
.ZE
$X~rel~Y$ is the set of relations between $X$ and $Y$,
that is, the set of all sets of ordered pairs whose first members
are members of $X$ and whose second members are members of $Y$.
'\"-------------------
.NH 2
Total functions
.LP
.Zo fx U+2192
.ZH
generic 5 rightassoc ( _ fx _ )
.ZE
.ZH
X fx Y == { f : X rel Y | forall x : X dot exists^1 y : Y dot (x , y) mem f }
.ZE
$X~fx~Y$ is the set of all total functions from $X$ to $Y$,
that is, the set of all relations between $X$ and $Y$
such that each $x$ in $X$ is related to exactly one $y$ in $Y$.
'\"-------------------------
.NH 1
Sets
'\"-------------------
.NH 2
Inequality relation
.LP
.Zo <> U+2260
.ZH
relation ( _ <> _ )
.ZE
.ZS [X]
_ <> _ : X rel X
.ZM
forall x , y : X dot x <> y iff neg x = y
.ZE
Inequality is the relation between those values of the same type
that are not equal to each other.
'\"-------------------
.NH 2
Non-membership
.LP
.Zo notmem U+2209
.ZH
relation ( _ notmem _ )
.ZE
.ZS [X]
_ notmem _ : X rel ps X
.ZM
forall x : X ; a : ps X dot x notmem a iff neg x mem a
.ZE
Non-membership is the relation between those values of a type, $x$,
and sets of values of that type, $a$,
for which $x$ is not a member of $a$.
'\"-------------------
.NH 2
Empty set
.LP
.Zo empty U+2205
.ZH
empty [X] == { x : X | false }
.ZE
The empty set of any type is the set of that
type that has no members.
'\"-------------------
.NH 2
Subset relation
.LP
.Zo sinc U+2286
.ZH
relation ( _ sinc _ )
.ZE
.ZS [X]
_ sinc _ : ps X rel ps X
.ZM
forall a , b : ps X dot a sinc b iff
( forall x : a dot x mem b )
.ZE
Subset is the relation between two sets of the same type, $a$ and $b$,
such that every member of $a$ is a member of $b$.
'\"-------------------
.NH 2
Proper subset relation
.LP
.Zo ssinc U+2282
.ZH
relation ( _ ssinc _ )
.ZE
.ZS [X]
_ ssinc _ : ps X rel ps X
.ZM
forall a , b : ps X dot a ssinc b iff
a sinc b and a <> b
.ZE
Proper subset is the relation between two
sets of the same type, $a$ and $b$,
such that $a$ is a subset of $b$,
and $a$ and $b$ are not equal.
'\"-------------------
.NH 2
Non-empty subsets
.LP
.ZH
ps^1 X == { a : ps X | a <> empty }
.ZE
If $X$ is a set, then $ps sub 1~X$ is the set of all non-empty subsets of $X$.
'\"-------------------
.NH 2
Set union
.LP
.Zo sor U+222A
.ZH
function 30 leftassoc ( _ sor _ )
.ZE
.ZS [X]
_ sor _ : ps X cp ps X fx ps X
.ZM
forall a , b : ps X dot a sor b = { x : X | x mem a or x mem b }
.ZE
The union of two sets of the same type is the set of values
that are members of either set.
'\"-------------------
.NH 2
Set intersection
.LP
.Zo sand U+2229
.ZH
function 40 leftassoc ( _ sand _ )
.ZE
.ZS [X]
_ sand _ : ps X cp ps X fx ps X
.ZM
forall a , b : ps X dot a sand b = { x : X | x mem a and x mem b }
.ZE
The intersection of two sets of the same type is the set of
values that are members of both sets.
'\"-------------------
.NH 2
Set difference
.LP
.Zo sdiff U+005C
.ZH
function 30 leftassoc ( _ sdiff _ )
.ZE
.ZS [X]
_ sdiff _ : ps X cp ps X fx ps X
.ZM
forall a , b : ps X dot a sdiff b = { x : X | x mem a and x notmem b }
.ZE
The difference of two sets of the same type is the set of
values that are members of the first set but not members of the second set.
'\"-------------------
.NH 2
Set symmetric difference
.LP
.Zo symdiff U+2296
.ZH
function 25 leftassoc ( _ symdiff _ )
.ZE
.ZS [X]
_ symdiff _ : ps X cp ps X fx ps X
.ZM
forall a , b : ps X dot a symdiff b = { x : X | neg ( x mem a iff x mem b) }
.ZE
The symmetric set difference of two sets of the same type is
the set of values that are members of one set, or the other,
but not members of both.
'\"-------------------
.NH 2
Generalized union
.LP
.Zo dor U+22C3
.ZS [X]
dor : ps ps X fx ps X
.ZM
forall A : ps ps X dot dor A = { x : X | exists a : A dot x mem a }
.ZE
The generalized union of a set of sets of the same type is
the set of values of that type that are members of at least one of the sets.
'\"-------------------
.NH 2
Generalized intersection
.LP
.Zo dand U+22C2
.ZS [X]
dand : ps ps X fx ps X
.ZM
forall A : ps ps X dot dand A = { x : X | forall a : A dot x mem a }
.ZE
The generalized intersection of a set of sets of values of the same
type is the set of values of that type that are members of
every one of the sets.
'\"-------------------------
.NH 1
Finite sets
'\"-------------------
.NH 2
Finite subsets
.LP
.Zo fss U-0001D53D
.ZH
generic ( fss _ )
.ZE
.ZH
fss X == dand { A : ps ps X |
	empty mem A and ( forall a : A ; x : X dot a sor { x } mem A ) }
.ZE
If $X$ is a set,
then $fss~X$ is the set of all finite subsets of $X$.
The set of finite subsets of $X$ is the smallest set that contains the empty set
and is closed under the action of adding single elements of $X$.
'\"-------------------
.NH 2
Non-empty finite subsets
.LP
.ZH
fss^1 X == fss X sdiff { empty }
.ZE
If $X$ is a set,
then $fss sub 1~X$ is the set of all non-empty finite subsets of $X$.
The set of non-empty finite subsets of $X$ is the smallest set that contains
the singleton sets of $X$ and is closed under the action of adding single
elements of $X$.
