'\"<-xtx-*>eqn -Tpsc $CADIZ/mip/pub/zchars $XTX >number_toolkit.z ; cadiz -l number_toolkit
.EQ
delim $$
gfont HR
.EN
.TL
Mathematical toolkit
.AU
This is public domain material,
.br
as presented in the Z Standard (ISO/IEC 13568:2002).
'\"-------------------------
.NH 1
Numbers
.LP
'\"-------------------------
.ZH
section number_toolkit
.ZE
.NH 2
Successor
.LP
.ZH
function (succ _)
.ZE
.ZS
succ _ : ps (nn cp nn)
.ZM
(succ _) = lambda n : nn dot n+1
.ZE
The successor of a natural number $n$ is equal to $n+1$.
'\"-------------------
.NH 2
Integers
.LP
.Zo ints U+2124
.ZS
ints : ps arithmos
.ZE
$ints$ is the set of integers,
that is, positive and negative whole numbers and zero.
The set $ints$ is characterised by axioms for its additive structure given
in the prelude together with
the next formal paragraph below.

Number systems that extend the integers
may be specified as supersets of $ints$.
'\"-------------------
.NH 2
Addition of integers, arithmetic negation
.LP
.Zo negate U+002D
.ZH
function (negate _)
.ZE
.ZS
negate _ : ps (arithmos cp arithmos)
.ZM
forall x, y : ints dot exists^1 z : ints dot ((x,y),z) mem (_ + _)
forall x : ints dot exists^1 y : ints dot (x,y) mem (negate _)
forall i , j , k : ints dot
 ( i + j ) + k = i + ( j + k )
 and i + j = j + i
 and i + negate i = 0
 and i + 0 = i
ints = { z : arithmos | exists x : nn dot z = x or z = negate x }
.ZE
The binary addition operator $(_~+~_)$ is defined in the prelude.
The definition here introduces additional properties for integers.
The addition and negation operations on integers are total functions that
take integer values.
The integers form a commutative group under $(_~+~_)$ with $(- _)$ as
the inverse operation and $0$ as the identity element.

.ZQ 1
.ZR 1
NOTE  If $function_toolkit$ notation were exploited,
the negation operator could be defined as follows.
.ZS
negate _ : arithmos pfun arithmos
.ZM
( ints cp ints ) dres ( _ + _ ) mem ints cp ints fun ints
ints dres (negate _) mem ints fun ints
forall i , j , k : ints dot
  ( i + j ) + k = i + ( j + k )
  and i + j = j + i
  and i + negate i = 0
  and i + 0 = i
forall h : ps ints dot
  1 mem h
        and ( forall i , j : h dot i + j mem h and negate i mem h )
          imp h = ints
.ZE
.ZR 0
.ZQ 0
'\"-------------------
.NH 2
Subtraction
.LP
.ZH
function 30 leftassoc ( _ - _ )
.ZE
.ZS
_ - _ : ps ((arithmos cp arithmos) cp arithmos)
.ZM
forall x, y : ints dot exists^1 z : ints dot ((x,y),z) mem (_ - _)
forall i , j : ints dot i - j = i + negate j
.ZE
Subtraction is a function whose domain includes all pairs of integers.
For all integers $i$ and $j$,
$i~-~j$ is equal to $i~+~-j$.

.ZQ 1
.ZR 1
NOTE  If $function_toolkit$ notation were exploited,
the subtraction operator could be defined as follows.
.ZS
_ - _ : arithmos cp arithmos pfun arithmos
.ZM
( ints cp ints ) dres ( _ - _ ) mem ints cp ints fun ints
forall i , j : ints dot i - j = i + negate j
.ZE
.ZR 0
.ZQ 0
'\"-------------------
.NH 2
Less-than-or-equal
.LP
.Zo <= U+2264
.ZH
relation ( _ <= _ )
.ZE
.ZS
_ <= _ : ps (arithmos cp arithmos)
.ZM
forall i , j : ints dot i <= j iff j - i mem nn
.ZE
For all integers $i$ and $j$,  $i~<=~j$ if and only if
their difference $j~-~i$ is a natural number.
'\"-------------------
.NH 2
Less-than
.LP
.ZH
relation ( _ < _ )
.ZE
.ZS
_ < _ : ps (arithmos cp arithmos)
.ZM
forall i , j : ints dot i < j iff i + 1 <= j
.ZE
For all integers $i$ and $j$,
$i~<~j$ if and only if $i~+~1~<=~j$.
'\"-------------------
.NH 2
Greater-than-or-equal
.LP
.Zo >= U+2265
.ZH
relation ( _ >= _ )
.ZE
.ZS
_ >= _ : ps (arithmos cp arithmos)
.ZM
forall i , j : ints dot i >= j iff j <= i
.ZE
For all integers $i$ and $j$,
$i~>=~j$ if and only if $j~<=~i$.
'\"-------------------
.NH 2
Greater-than
.LP
.ZH
relation ( _ > _ )
.ZE
.ZS
_ > _ : ps (arithmos cp arithmos)
.ZM
forall i , j : ints dot i > j iff j < i
.ZE
For all integers $i$ and $j$,
$i~>~j$ if and only if $j~<~i$.
'\"-------------------
.NH 2
Strictly positive natural numbers
.LP
.ZS
nn^1 == { x : nn | neg x = 0 }
.ZE
The strictly positive natural numbers $nn sub 1$
are the natural numbers except zero. 
'\"-------------------
.NH 2
Non-zero integers
.LP
.ZS
ints^1 == { x : ints | neg x = 0 }
.ZE
The non-zero integers $ints sub 1$ are the integers except zero. 
'\"-------------------
.NH 2
Multiplication of integers
.LP
.ZH
function 40 leftassoc ( _ * _ )
.ZE
.ZS
_ * _ : ps ((arithmos cp arithmos) cp arithmos)
.ZM
forall x, y : ints dot exists^1 z : ints dot ((x,y),z) mem (_ * _)
forall i , j , k : ints dot
	( i * j ) * k = i * ( j * k )
	and i * j = j * i
	and i * ( j + k ) = i * j + i * k
	and 0 * i = 0
	and 1 * i = i
.ZE
The binary multiplication operator $(_~*~_)$ is defined for integers.
The multiplication operation on integers
is a total function and has integer values.
Multiplication on integers is characterised by the unique operation under
which the integers become a commutative ring with identity element $1$.

.ZQ 1
.ZR 1
NOTE  If $function_toolkit$ notation were exploited,
the multiplication operator could be defined as follows.
.ZS
_ * _ : (arithmos cp arithmos) pfun arithmos
.ZM
( ints cp ints ) dres ( _ * _ ) mem ints cp ints fun ints
forall i , j , k : ints dot
  ( i * j ) * k = i * ( j * k )
  and i * j = j * i
  and i * ( j + k ) = i * j + i * k
  and 0 * i = 0
  and 1 * i = i
.ZE
.ZR 0
.ZQ 0
'\"-------------------
.NH 2
Division, modulus
.LP
.ZH
function 40 leftassoc ( _ div _ )
function 40 leftassoc ( _ mod _ )
.ZE
.ZS
_ div _ , _ mod _ : ps ((arithmos cp arithmos) cp arithmos)
.ZM
forall x : ints ; y : ints^1 dot exists^1 z : ints dot ((x,y),z) mem (_ div _)
forall x : ints ; y : ints^1 dot exists^1 z : ints dot ((x,y),z) mem (_ mod _)
forall i : ints ; j : ints^1 dot
	i = ( i div j ) * j + i mod j
	and ( 0 <= i mod j < j  or  j < i mod j <= 0 )
.ZE
For all integers $i$ and non-zero integers $j$,
the pair $(i, j)$ is in the domain of $_~div~_$ and of $_~mod~_$,
and $i~div~j$ and $i~mod~j$ have integer values.

When not zero, $i~mod~j$ has the same sign as $j$.
This means that $i~div~j$ is the largest integer no greater
than the rational number $i/j$.

.ZQ 1
.ZR 1
NOTE  If $function_toolkit$ notation were exploited,
the division and modulus operators could be defined as follows.
.ZS
_ div _ , _ mod _ : arithmos cp arithmos pfun arithmos
.ZM
( ints cp ints^1 ) dres ( _ div _ ) mem ints cp ints^1 fun ints
( ints cp ints^1 ) dres ( _ mod _ ) mem ints cp ints^1 fun ints
forall i : ints ; j : ints^1 dot
  i = ( i div j ) * j + i mod j
  and ( 0 <= i mod j < j  or  j < i mod j <= 0 )
.ZE
.ZR 0
.ZQ 0
